#pragma once

#include <memory>
#include "classicmode/context.h"

class HoldManager;
class ClassicGraphicsManager;

class GameContext : public Context
{
public:
    explicit GameContext(const std::shared_ptr<HoldManager>& hold_manager,
                         const std::shared_ptr<ClassicGraphicsManager>& graphics_manager);

    virtual void input(ClassicArrowNote *note, kku::GameEvent&& input) const override;
    virtual void update(ClassicArrowNote *note, const kku::microsec &music_offset) const override;

    std::shared_ptr<HoldManager> getHoldManager() const;
    std::shared_ptr<ClassicGraphicsManager> getGraphicsManager() const;

private:
    const std::shared_ptr<HoldManager> _hold_manager;
    const std::shared_ptr<ClassicGraphicsManager> _graphics_manager;
};
